#!/usr/bin/perl

# $Id: make_homedirs.pl,v 1.2 2012/11/13 06:34:30 peter Exp $

use strict;
use warnings;

# Do a sweep through the system's /etc/passwd now and see if we can help out with missing homedirs
# Note: this is intended to be conservative, and a failure is quite ok.
my ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire);
my ($grpgid);
while (($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire) = getpwent()) {
	#1: $user must have /home/$user
	next unless ($dir eq "/home/$name");
	#2: whitelist shells (maybe add cvssh/svnssh)
	next unless ($shell =~ /\/(csh|tcsh|zsh|bash|sh|svnssh|cvssh|ksh)$/);
	#3: if it exists (including a symlink), leave it alone
	next if (-e $dir);
	#4: prefer to use $group as gid because of history.
	$grpgid = (getgrnam($name) || $gid);
	#print "++ $name $dir $shell $grpgid $uid\n";
	#5 failure is quite acceptable
	mkdir($dir, 0755);
	chown($uid, $grpgid, $dir);
}
