#! /usr/bin/perl
#
# from: Id: maybemail,v 1.8 1995/04/11 10:42:24 peter Exp
#
# Conditionally send mail if data recieved on STDIN

use strict;
use warnings;

use Getopt::Std;
use Sys::Hostname;

# -s subject
# -f fromuser
# -d domain
# -H           (allow sender to add more headers)
# ... recipient [ .. reclipient ]

# declare the perl command line flags/options we want to allow
my %options=();
getopts("s:f:d:H", \%options) || die("rtfm");

my $subj = "no subject";
if (defined ($options{s})) {
	$subj = $options{s};
}

my $user = getpwuid($<);
if (defined ($options{f})) {
	$user = $options{f};
}

my ($name, $passwd, $uid, $gid, $quota, $comment, $gcos, $dir, $shell) = getpwnam($user);
my $host = hostname;
$gcos = "FreeBSD $user" unless defined($gcos);
$name = $user unless defined($name);
if (defined ($options{d})) {
	$host = $options{d};
}
$gcos =~ s/,.*//;
$gcos =~ s/\&/$name/;
my $from = "$gcos <$name\@$host>";


my $opened = 0;

while ( <STDIN> ) {
  if (!$opened) {
    my $to = join(', ', @ARGV);
    grep($_ = '"' . $_ . '"', @ARGV);
    my $recips = join(' ', @ARGV);
    my $mailcmd = "/usr/sbin/sendmail -f$name\@$host $recips";
    #print "mailcmd: $mailcmd\n";
    #$mailcmd = "/bin/cat";
    open(MAILPIPE, "|$mailcmd");
    print MAILPIPE "From: $from\n";
    print MAILPIPE "To: $to\n";
    print MAILPIPE "Subject: $subj\n";
    print MAILPIPE "\n" unless defined($options{H});
    $opened = 1;
  }
  print MAILPIPE $_;
}
if ($opened) {
  close(MAILPIPE);
}
